using System;

namespace HogeHogeCube
{
	/// <summary>
	/// ʃf[^
	/// </summary>
	public class FaceData
	{
		/// <summary>
		/// 𔺂ȂRXgN^
		/// </summary>
		/// <param name="size">TCY</param>
		public FaceData(int size)
		{
			m_size = size;
			m_data = new int[size, size];
		}

		/// <summary>
		/// 𔺂RXgN^
		/// </summary>
		/// <param name="size">TCY</param>
		/// <param name="n">l</param>
		public FaceData(int size, int n) :
			this(size)
		{
			fill(n);
		}

		/// <summary>
		/// f[^őŜ𖄂߂܂
		/// </summary>
		/// <param name="n">f[^</param>
		public void fill(int n)
		{
			for(int x = 0; x < m_size; ++x)
			{
				for(int y = 0; y < m_size; ++y)
				{
					m_data[x, y] = n;
				}
			}
		}

		/// <summary>
		/// ʂ̌PƂŕύX
		/// ʂ̃f[^w肵ɉ]܂
		/// {͘AM͌yƂ͎v̂łA
		/// A̕ςl̂\ʓ|L̂
		/// 蔲Œڃf[^Mĉ]Ă܂
		/// </summary>
		/// <param name="dir">݂̌̑Ε</param>
		public void rotateData(Direction dir)
		{
			switch(dir)
			{
				case Direction.Up:
					break;

				case Direction.Right:
				{
					int[,] data = new int[m_size, m_size];
					for(int x = 0; x < m_size; ++x)
					{
						for(int y = 0; y < m_size; ++y)
						{
							data[m_size - 1 - y, x] = m_data[x, y];
						}
					}
					m_data = data;
					break;
				}

				case Direction.Down:
				{
					int[,] data = new int[m_size, m_size];
					for(int x = 0; x < m_size; ++x)
					{
						for(int y = 0; y < m_size; ++y)
						{
							data[m_size - 1 - x, m_size - 1 - y] = m_data[x, y];
						}
					}
					m_data = data;
					break;
				}

				case Direction.Left:
				{
					int[,] data = new int[m_size, m_size];
					for(int x = 0; x < m_size; ++x)
					{
						for(int y = 0; y < m_size; ++y)
						{
							data[y, m_size - 1 - x] = m_data[x, y];
						}
					}
					m_data = data;
					break;
				}

				default:
					break;
			}
		}

		/// <summary>
		/// ׂ̖ʂ擾
		/// </summary>
		/// <param name="dir"></param>
		/// <returns>ʂ̏</returns>
		public Face getNext(Direction dir)
		{
			return m_next[(int)dir];
		}

		/// <summary>
		/// ׂ̖ʂݒ
		/// </summary>
		/// <param name="next">ׂ̖ʂɊւ</param>
		public void setNext(Face[] next)
		{
			m_next = next;
		}

		/// <summary>
		/// w肵ʒũf[^̎擾
		/// </summary>
		/// <param name="dir">sŖʂ̏ƌȂi₱j</param>
		/// <param name="i">sԍ</param>
		/// <param name="j">ԍ</param>
		public int this[Direction dir, int x, int y]
		{
			get
			{
				Index2 index = getInnerIndex(dir, x, y);
				return m_data[index.X, index.Y];
			}
			set
			{
				Index2 index = getInnerIndex(dir, x, y);
				m_data[index.X, index.Y] = value;
			}
		}
		/// <summary>
		/// ʂ̌ƍWAs m_data ̃CfbNXɕϊ
		/// </summary>
		/// <param name="dir">sŖʂ̏ƌȂi₱j</param>
		/// <param name="x">ԍ</param>
		/// <param name="y">sԍ</param>
		/// <returns></returns>
		private Index2 getInnerIndex(Direction dir, int x, int y)
		{
			switch(dir)
			{
				case Direction.Up:
					return new Index2(             x,              y);
				case Direction.Right:
					return new Index2(m_size - 1 - y,              x);
				case Direction.Down:
					return new Index2(m_size - 1 - x, m_size - 1 - y);
				case Direction.Left:
					return new Index2(             y, m_size - 1 - x);
				default:
					throw new DirectionException(dir);
			}
		}

		#region tB[h
		/// <summary>
		/// ʃf[^
		/// </summary>
		private int[,] m_data;

		/// <summary>
		/// ׂ̖
		/// </summary>
		private Face[] m_next;

		/// <summary>
		/// ʂ̃TCYiӂ̕j
		/// </summary>
		private int m_size;
		#endregion
	}

	struct Index2
	{
		public int X, Y;

		public Index2(int x, int y)
		{
			X = x;
			Y = y;
		}
	}
}
